#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "about.h"
#include "pixmap.h"
#include "eggtrayicon.h"
#include "trayicon.h"
#include "utils.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

GtkWidget*
create_dialog_about (void)
{
  GtkWidget *dialog_about;
  GtkWidget *dialog_vbox1;
  GtkWidget *label1;
  GtkWidget *dialog_action_area1;
  GtkWidget *closebutton1;

  dialog_about = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dialog_about), _("gneur - X Neural Switcher"));
  gtk_window_set_type_hint (GTK_WINDOW (dialog_about), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox1 = GTK_DIALOG (dialog_about)->vbox;
  gtk_widget_show (dialog_vbox1);

  label1 = gtk_label_new (_("gneur - X Neural Switcher.\nIt's program like Punto Switcher for Linux"));
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), label1, TRUE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_CENTER);

  dialog_action_area1 = GTK_DIALOG (dialog_about)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  closebutton1 = gtk_button_new_from_stock ("gtk-close");
  gtk_widget_show (closebutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dialog_about), closebutton1, GTK_RESPONSE_CLOSE);
  GTK_WIDGET_SET_FLAGS (closebutton1, GTK_CAN_DEFAULT);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (dialog_about, dialog_about, "dialog_about");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog_about, dialog_vbox1, "dialog_vbox1");
  GLADE_HOOKUP_OBJECT (dialog_about, label1, "label1");
  GLADE_HOOKUP_OBJECT_NO_REF (dialog_about, dialog_action_area1, "dialog_action_area1");
  GLADE_HOOKUP_OBJECT (dialog_about, closebutton1, "closebutton1");

  return dialog_about;
}
