/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Originally written by Alphex Kaanoken <kaanoken@crew.org.ru>
 *
 *  NOTE: This is frontend for some usually used functions like malloc,
 *  it's purposes to make code good-like without many check and other
 *
 *  (c) Crew IT Research Labs 2004
 *
 */

#ifndef _UTILS_H_
#define _UTILS_H_

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <gtk/gtk.h>

#include "xconfig.h"
#include "about.h"

/*it makes code simply for reading and modify*/
void _panic(void);

/*front-end functions*/
void *_malloc(int bytes);
void *_calloc(int block,int bytes);

// About window
GtkWidget *wAbout;
GtkWidget *vb1About;//*vbox1;
GtkWidget *l2About;//*label2;
GtkWidget *i2About;//*image2;
GtkWidget *hb1About;//*hbox1;
GtkWidget *btnOK;
GtkWidget *a1About;//*alignment1;
GtkWidget *hb2About;//*hbox2;
GtkWidget *i1About;//*image1;
GtkWidget *l1About;//*label1;
// About window End

// Preference window
GtkWidget *wPreference;
GtkWidget *vbox1;
GtkWidget *hbox2;
GtkWidget *label1;
GtkWidget *cboxMode;
GtkWidget *hseparator1;
GtkWidget *label2;
GtkWidget *hbox3;
GtkWidget *scrllAppList;
GtkWidget *treeview1;
GtkWidget *vbox2;
GtkWidget *btnAddApp;
GtkWidget *btnRemApp;
GtkWidget *hseparator2;
GtkWidget *label3;
GtkWidget *hbox4;
GtkWidget *label4;
GtkWidget *combobox4;
GtkWidget *combobox3;
GtkWidget *hbox7;
GtkWidget *label7;
GtkWidget *combobox5;
GtkWidget *combobox6;
GtkWidget *hbox8;
GtkWidget *label8;
GtkWidget *combobox7;
GtkWidget *combobox8;
GtkWidget *hbox9;
GtkWidget *label9;
GtkWidget *combobox9;
GtkWidget *combobox10;
GtkWidget *hbox1;
GtkWidget *btnClosePref;
GtkWidget *btnOKPref;
GtkTooltips *tooltips;
GtkTextBuffer *buffer;
GtkListStore *store;
GtkCellRenderer *cell;
GtkTreeViewColumn *column;
// Preference window End

void xneur_exit (GtkMenuItem *menuitem,xconf *xnc);
void xneur_preference (GtkWidget *widget,xconf *xnc);
void xneur_change_mode (GtkMenuItem *menuitem,xconf *xnc);
void xneur_about (GtkWidget *widget,xconf *xnc);
void xneur_load_preference (xconf *xnc);
void xneur_save_preference (xconf *xnc);
void xneur_add_application ();
void xneur_rem_application ();
#endif
