/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "xClientManager.h"
#include "error.h"

status xClientManager_getClientInfo (xEvent * xevent, xIFocus * xifocus)
{
	status err = SUCCESS;

	err = xIFocus_update (xifocus);
	//ERROR if None
	if (ERROR == err)
		return err;
	if (!xIFocus_hasChanged (xifocus)) {
		return WARNING;
	}

	err = xEvent_setCommunicator (xevent, xifocus->owner);

	return err;
}

bool xClientManager_testAppName (xIFocus * xifocus, app_list * sup_apps_list)
{
	num have_name = 0;
	char *app_name = NULL;

	app_name = xObject_getWMClass_class (xifocus->owner);
	if (app_name == NULL)
		return FALSE;	//may be client is dead?

	while (sup_apps_list != NULL) {
		if (!strncmp
		    ((char *) sup_apps_list->name, (char *) app_name,
		     strlen ((char *) sup_apps_list->name)))
			++have_name;
		sup_apps_list = sup_apps_list->next;
	}

	free (app_name);

	if (have_name < 1) {
		if (xIFocus_hasChanged (xifocus))
			send_error (DEBUG, "Not in list!\n", NULL);
		return FALSE;
	}
}

status xClientManager_beginToListenClient (xIFocus * xifocus)
{
	status err;
	num iterator;
		
	err = xObject_setEventMask (xifocus->owner, CLIENT_EVENT_MASK);
	if (err == ERROR)
		return err;
	else{
		for(iterator = 0; iterator < xifocus->ptr_num; iterator++)
			err = xObject_setEventMask (xifocus->ptr[iterator], CLIENT_EVENT_MASK);
	}
	return err;
}
