/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *	Originally written by Art Vodolazsky <burivuh@crew.org.ru>
 *
 */

#ifndef _XPROGRAM_H
#define _XPROGRAM_H

#include "types.h"
#include "error.h"
#include "xSelectManager.h"
#include "xKeyLogManager.h"
#include "xClientManager.h"
#include "xconfig.h"

#define TIME_TO_WAIT_SEL_OWNER 1000

void xProgram_exit ();
bool xProgram_isExiting ();

typedef struct {
	xObject *xobject;
	xString *xword;
	xString *xstring;
	xSwitchLang *xswitchlang;
	xSelection *xselection;
	xEvent *xevent;
	xIFocus *xifocus;
	xKeyLogBuffer *xklbuffer;
	xBindingTable *xbtable;
} xProgramInfo;

xProgramInfo *xProgram_init (xconf* xnc);

status xProgram_free (xProgramInfo * toDelete);

bool xProgram_update (xProgramInfo * xinfo, app_list * sup_apps_list);

num xProgram_processInput (xProgramInfo * xinfo);

bool xProgram_performCurrentBind (xProgramInfo * xinfo, xconf* xnc);

status xProgram_performCurrentMode (xProgramInfo * xinfo, xconf * CurrentMode);

status xProgram_changeWordBySelection (xProgramInfo * xinfo, status lang);
status xProgram_changeStringBySelection (xProgramInfo * xinfo, status lang);

status xProgram_getCurrentLang (xProgramInfo * xinfo);

#endif /* _XPROGRAM_H */
